/*
 * This file was generated by qdbusxml2cpp version 0.7
 * Command line was: qdbusxml2cpp -i configurationtype.h -i sigmodelstype.h -i vendormodelstype.h -a adaptor dbus.xml
 *
 * qdbusxml2cpp is Copyright (C) 2015 The Qt Company Ltd.
 *
 * This is an auto-generated file.
 * This file may have been hand-edited. Look for HAND-EDIT comments
 * before re-generating it.
 */

#ifndef ADAPTOR_H_1600719816
#define ADAPTOR_H_1600719816

#include <QtCore/QObject>
#include <QtDBus/QtDBus>
#include "configurationtype.h"
#include "sigmodelstype.h"
#include "vendormodelstype.h"
class QByteArray;
template<class T> class QList;
template<class Key, class Value> class QMap;
class QString;
class QStringList;
class QVariant;

/*
 * Adaptor class for interface org.bluez.mesh.Element1
 */
class Element1Adaptor: public QDBusAbstractAdaptor
{
    Q_OBJECT
    Q_CLASSINFO("D-Bus Interface", "org.bluez.mesh.Element1")
    Q_CLASSINFO("D-Bus Introspection", ""
"  <interface name=\"org.bluez.mesh.Element1\">\n"
"    <method name=\"MessageReceived\">\n"
"      <arg direction=\"in\" type=\"q\" name=\"source\"/>\n"
"      <arg direction=\"in\" type=\"q\" name=\"key_index\"/>\n"
"      <arg direction=\"in\" type=\"v\" name=\"destination\"/>\n"
"      <arg direction=\"in\" type=\"ay\" name=\"data\"/>\n"
"    </method>\n"
"    <method name=\"DevKeyMessageReceived\">\n"
"      <arg direction=\"in\" type=\"q\" name=\"source\"/>\n"
"      <arg direction=\"in\" type=\"b\" name=\"remote\"/>\n"
"      <arg direction=\"in\" type=\"q\" name=\"net_index\"/>\n"
"      <arg direction=\"in\" type=\"ay\" name=\"data\"/>\n"
"    </method>\n"
"    <method name=\"UpdateModelConfiguration\">\n"
"      <arg direction=\"in\" type=\"q\" name=\"model_id\"/>\n"
"      <arg direction=\"in\" type=\"a{sv}\" name=\"config\"/>\n"
"      <annotation value=\"Oscl::Qt::DBus::BlueZ::Mesh::Element1::ConfigurationType\" name=\"org.qtproject.QtDBus.QtTypeName.In1\"/>\n"
"    </method>\n"
"    <property access=\"read\" type=\"y\" name=\"Index\"/>\n"
"    <property access=\"read\" type=\"a(qa{sv})\" name=\"Models\">\n"
"      <annotation value=\"Oscl::Qt::DBus::BlueZ::Mesh::Element1::SigModelsType\" name=\"org.qtproject.QtDBus.QtTypeName\"/>\n"
"    </property>\n"
"    <property access=\"read\" type=\"a(qqa{sv})\" name=\"VendorModels\">\n"
"      <annotation value=\"Oscl::Qt::DBus::BlueZ::Mesh::Element1::VendorModelsType\" name=\"org.qtproject.QtDBus.QtTypeName\"/>\n"
"    </property>\n"
"    <property access=\"read\" type=\"q\" name=\"Location\"/>\n"
"  </interface>\n"
        "")
public:
    Element1Adaptor(QObject *parent);
    virtual ~Element1Adaptor();

public: // PROPERTIES
    Q_PROPERTY(uchar Index READ index)
    uchar index() const;

    Q_PROPERTY(ushort Location READ location)
    ushort location() const;

    Q_PROPERTY(Oscl::Qt::DBus::BlueZ::Mesh::Element1::SigModelsType Models READ models)
    Oscl::Qt::DBus::BlueZ::Mesh::Element1::SigModelsType models() const;

    Q_PROPERTY(Oscl::Qt::DBus::BlueZ::Mesh::Element1::VendorModelsType VendorModels READ vendorModels)
    Oscl::Qt::DBus::BlueZ::Mesh::Element1::VendorModelsType vendorModels() const;

public Q_SLOTS: // METHODS
    void DevKeyMessageReceived(ushort source, bool remote, ushort net_index, const QByteArray &data);
    void MessageReceived(ushort source, ushort key_index, const QDBusVariant &destination, const QByteArray &data);
    void UpdateModelConfiguration(ushort model_id, Oscl::Qt::DBus::BlueZ::Mesh::Element1::ConfigurationType config);
Q_SIGNALS: // SIGNALS
};

#endif
